# -*- coding: utf-8 -*-
from setuphelpers import *

def install():
    # Declaring local variables
    zip_name = glob.glob("*.zip")[0]
    unzip(zip_name, zip_name.replace('.zip',''))
    dll = glob.glob(r'*\*.dll')[0]
    # plugin directory is retrieved from the dll name
    plugin = dll.replace('.dll','').split('\\')[-1]
    plugin_dir = makepath(programfiles,"Notepad++","plugins",plugin)

    # writing plugin_dir in a file inside persistent_dir
    with open(makepath(persistent_dir,'plugindir'),'w') as p:
        p.write(plugin_dir)
        p.close()

    if not isdir(plugin_dir):
        mkdirs(plugin_dir)
        print("Plugin Installation")
        filecopyto(dll,plugin_dir)

    else:
        print("Plugin already installed")

def uninstall():

    # Getting plugin_dir from the file present in persistent_dir
    with open(makepath(persistent_dir,'plugindir'),'r') as p:
        plugin_dir = p.read()
        p.close()

    if isdir(plugin_dir):
        print("Plugin removed")
        remove_tree(plugin_dir)
    else:
        print("Plugin not present")