# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import waptguihelper


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    #list of all plugins is in this json file
    json_url = "https://raw.githubusercontent.com/notepad-plus-plus/nppPluginList/refs/heads/master/src/pl.x64.json"
    wget(json_url,'pl.x64.json',proxies=proxies)

    with open('pl.x64.json','r') as j:
        data = json.load(j)

    # Extract plugins list
    plugins = data.get("npp-plugins", [])

    # Check if list contains plugins
    if not plugins:
        print("Aucun plugin trouvé.")
    else:
        # plugin list
        plugins_list = [plugin['display-name'] for plugin in plugins]
        # plugin_name/download_URL dict
        plugins_dict = {plugin['display-name']: plugin['repository'] for plugin in plugins}
        # Selecting plugin from list
        selected_plugin_dict = waptguihelper.grid_dialog('Please select plugin (only one plugin)',plugins_list,waptguihelper.GRT_SELECTED,'{"columns":[{"propertyname":"plugins","datatype":"String"}]}')[0]
        # Getting download URL from plugin name
        selected_plugin = selected_plugin_dict['unknown']
        dl_url = plugins_dict[selected_plugin]
        # Downloading plugin
        wget(dl_url,dl_url.split('/')[-1],proxies=proxies)

    # Renaming package
    if "template" in control.package:
        complete_control_package(control)
        complete_control_name(control)
        complete_control_description(control)
        complete_control_version(control,control.version)
        if "template" in control.package:
            error("Please rename the package.")
        else:
            version = str(int(control.get_software_version()) + 1)
    else:
        version = str(int(control.get_software_version()))

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print(
            "Software version updated (from: %s to: %s)"
            % (control.get_software_version(), Version(version))
        )
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
